#include <map>
#include <set>
#include <vector>
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <string.h>
#include <glpk.h>
#include <limits.h>

#define MAX_LEN 256

#define BWD 1
#define OUTPUT 4
#define SUMUNDERONE 8
#define INTERIOR 16

#define GLPK 2

using namespace std;

template <typename T> class Aton{
 private:
  int i;
  map<T,int> p;
 public:
  Aton();
  bool insert(T);
  int operator[](T);
  int size();
};
template <typename T> Aton<T>::Aton(){
  i = 0;
}
template <typename T> bool Aton<T>::insert(T s){
  bool b = p.insert(make_pair(s,i)).second;
  if (b) i++;
  return(b);
}
template <typename T> int Aton<T>::operator[](T s){
  return(p[s]);
}
template <typename T> int Aton<T>::size(){
  return(i);
}


int lcm(int,int);


pair<int,int> read_pre_apex(ifstream &ifs, Aton<string> &, map<string,int> &);
void read_body_apex(ifstream &, int ***, int *, int *, Aton<string> &, map<string,int> &, int, int);

pair<int,int> read_pre(ifstream &ifs, Aton<string> &nodes, Aton<string> &ac, map<string,int> &lt);
void read_body(ifstream &ifs, int ***c, int *cv, int *ci, Aton<string> &nodes, Aton<string> &ac, map<string,int> &lt, int lv, int li, int trans);

void make_output(int, int, int, int ***, int ***, set<int> &, map<int,vector<pair<int,int> > > &);
int solve_by_glpk(int, int, int, int ***, int *, int *, int ***, int *, int *, double *, int);

